const copy = (value, depth=1) => {
  if (depth < 0) {
    throw "Depth must be greater that zero"
  }

  if (!(value instanceof Object) || (typeof value === 'function')) {
    return value
  }

  if (depth == 0) {
    return Object.assign({}, value)
  }
  depth = depth - 1

  if (Array.isArray(value)) {
    return value.map( (value) => copy(value, depth) )
  }
  else {
    let valueCopy = {}
    for (let key in value) {
      let kValue = value[key]
      if (depth > 0) {
        kValue = copy(kValue, depth)
      }
      valueCopy[key] = kValue
    }
    return valueCopy
  }
}

module.exports = { copy };
